// Java class cwtch.Cwtch is a proxy for talking to a Go program.
//   gobind -lang=java git.openprivacy.ca/cwtch.im/libcwtch-go
//
// File is generated by gobind. Do not edit.
package cwtch;

import go.Seq;

public abstract class Cwtch {
	static {
		Seq.touch(); // for loading the native library
		_init();
	}
	
	private Cwtch() {} // uninstantiable
	
	// touch is called from other bound packages to initialize this package
	public static void touch() {}
	
	private static native void _init();
	
	
	// skipped const AddContact with unsupported type: cwtch.im/cwtch/event.Type
	
	// skipped const ImportString with unsupported type: cwtch.im/cwtch/event.Field
	
	// skipped const ProfileOnion with unsupported type: cwtch.im/cwtch/event.Field
	
	
	/**
	 * AcceptConversation takes in a profileOnion and a handle to either a group or a peer and authorizes the handle
	for further action (e.g. messaging / connecting to the server / joining the group etc.)
	 */
	public static native void acceptConversation(String profileOnion, long conversationID);
	/**
	 * ArchiveConversation sets the conversation to archived
	 */
	public static native void archiveConversation(String profileHandle, long conversationID);
	public static native void blockContact(String profileOnion, long conversationID);
	/**
	 * ChangePassword provides a wrapper around profile.ChangePassword
	 */
	public static native void changePassword(String profileOnion, String oldPassword, String newPassword, String newPasswordAgain);
	public static native void checkDownloadStatus(String profileOnion, String fileKey);
	/**
	 * CreateGroup takes in a profile and server in addition to a name and creates a new group.
	 */
	public static native void createGroup(String profileHandle, String server, String name);
	public static native void createProfile(String nick, String pass);
	public static native void createServer(String password, String description, boolean autostart);
	/**
	 * DeleteContact removes all trace of the contact from the profile
	 */
	public static native void deleteContact(String profileHandle, long conversationID);
	/**
	 * DeleteProfile deletes a profile given the right password
	 */
	public static native void deleteProfile(String profile, String password);
	public static native void deleteServer(String onion, String currentPassword);
	public static native void destroyServers();
	public static native void downloadFile(String profileOnion, long conversationID, String filepath, String manifestpath, String filekey);
	/**
	 * ExportProfile provides a wrapper around profile.ExportProfile
	 */
	public static native void exportProfile(String profileOnion, String file);
	/**
	 * GetAppBusEvent blocks until an event
	 */
	public static native String getAppBusEvent();
	/**
	 * GetGonversationAttribute provides a wrapper around profile.GetGonversationAttribute
	key is of format Scope.Zone.Key
	Returns json of an Attribute
	 */
	public static native String getConversationAttribute(String profileOnion, long conversationID, String key);
	public static native String getDebugInfo();
	public static native String getMessage(String profileOnion, long conversationID, long messageIndex);
	public static native String getMessageByID(String profileOnion, long conversationID, long messageID);
	public static native String getMessages(String profileOnion, long conversationID, long messageIndex, long count);
	public static native String getMessagesByContentHash(String profileOnion, long handle, String contentHash);
	/**
	 * GetProfileAttribute provides a wrapper around profile.GetScopedZonedAttribute
	Key must have the format zone.key where Zone is defined in Cwtch. Unknown zones are not permitted.
	Currently forcing the Public Scope
	Returns json of Attribute
	 */
	public static native String getProfileAttribute(String profileOnion, String key);
	/**
	 * ImportBundle takes in a handle to a profile and an invite string which could have one of many
	different formats (e.g. a peer address, a group invite, a server key bundle, or a combination)
	 */
	public static native void importBundle(String profileOnion, String bundle);
	/**
	 * ImportProfile is a wrapper around application.ImportProfile
	 */
	public static native String importProfile(String exportedCwtchFile, String pass);
	public static native void launchServer(String onion);
	public static native void launchServers();
	public static native void loadProfiles(String pass);
	public static native void loadServers(String password);
	/**
	 * Like StartCwtch, but StartCwtch has already been called so we don&#39;t need to restart Tor etc (probably)
	Do need to re-send initial state tho, eg profiles that are already loaded
	 */
	public static native void reconnectCwtchForeground();
	public static native void resetTor();
	/**
	 * SendAppEvent is a generic method for Rebroadcasting App Events from a UI
	 */
	public static native void sendAppEvent(String eventJson);
	/**
	 * SendInvitation sends an invitation from `profileOnion` to contact `handle` (peer or group)
	asking them to add the contact `target`  (also peer or group).
	For groups, the profile must already have `target` as a contact.
	 */
	public static native String sendInvitation(String profileOnion, long conversationID, long targetID);
	public static native String sendMessage(String profileOnion, long conversationID, String msg);
	/**
	 * SendProfileEvent is a generic method for Rebroadcasting Profile Events from a UI
	Should generally be used for rapidly prototyping new APIs
	 */
	public static native void sendProfileEvent(String onion, String eventJson);
	/**
	 * SetConversationAttribute provides a wrapper around profile.SetProfileAttribute
	key is of format Zone.Key, and the API forces the Local Scope
	 */
	public static native void setConversationAttribute(String profileOnion, long conversationID, String key, String value);
	/**
	 * SetMessageAttribute is a wrapper around `UpdateMessageAttribute` on profile that allows the creation or update of a
	given message attribute on a conversation/channel.
	Errors if `profileOnion` is not associated to an existing &amp; loaded profile,
	of if `UpdateMessageAttribute` fails
	 */
	public static native void setMessageAttribute(String profileOnion, long conversationID, long channelID, long messageID, String attributeKey, String attributeValue);
	/**
	 * SetProfileAttribute provides a wrapper around profile.SetScopedZonedAttribute
	WARNING: Because this function is potentially dangerous all keys and zones must be added
	explicitly. If you are attempting to added behaviour to the UI that requires the existence of new keys
	you probably want to be building out functionality/subsystem in the UI itself.
	Key must have the format zone.key where Zone is defined in Cwtch. Unknown zones are not permitted.
	 */
	public static native void setProfileAttribute(String profileOnion, String key, String value);
	public static native void setServerAttribute(String onion, String key, String val);
	public static native String shareFile(String profileOnion, long conversationID, String sharefilepath);
	/**
	 * ShutdownCwtch is a safe way to shutdown any active cwtch applications and associated ACNs
	 */
	public static native void shutdownCwtch();
	/**
	 * StartCwtch starts cwtch in the library and initlaizes all data structures
		 GetAppbusEvents is always safe to use
	  the rest of functions are unsafe until the CwtchStarted event has been received indicating StartCwtch has completed
	  returns:
	    message: CwtchStarted when start up is complete and app is safe to use
	             CwtchStartError message when start up fails (includes event.Error data field)
	 */
	public static native long startCwtch(String appDir, String torPath);
	/**
	 * Started returns 1 if application is initialized and 0 if it is null
	 */
	public static native long started();
	public static native void stopServer(String onion);
	public static native void stopServers();
	public static native void unblockContact(String profileOnion, long conversationID);
	public static native void verifyOrResumeDownload(String profileOnion, long conversationID, String fileKey);
}
